﻿using SlimDX.D3DCompiler;

namespace HlslCompiler
{
    public class CompilerSettings
    {

        /// <summary>
        /// Version of Direct3D to use.
        /// </summary>
        public string Direct3D { get; set; }

        /// <summary>
        /// Compiler profile: effect or shader profile.
        /// </summary>
        public string Profile { get; set; }

        /// <summary>
        /// Optional entrypoint in combination with shader profiles.
        /// </summary>
        public string EntryPoint { get; set; }

        public ShaderFlags ShaderFlags { get; set; }

        public EffectFlags EffectFlags { get; set; }

        public CompilerSettings Clone()
        {
            return new CompilerSettings() { Direct3D = Direct3D, Profile = Profile, EntryPoint = EntryPoint, ShaderFlags = ShaderFlags, EffectFlags = EffectFlags};
        }

    }
}


